require 'metasm'
include Metasm
require '../deobfuscate'
require '../analyse_handlers'
require '../macro_cpu_vm'
require '../decompile'

exe = AutoExe.decode_file '../driver.sys'
exe.cpu = Ia32_junkfilter.new
t2exe = exe.dup
t2exe.cpu = T2MacroCPU.new(exe)
t2exe.cpu.ia32dasm.cpu.showrdtsc = false
t2dasm = T2Disassembler.new(t2exe)

t2entry = T2Addr.new(0x13000+0xe9fe, 0x13000+0xeea6)

puts "disassembling t2vm from #{t2entry}"
t2dasm.disassemble t2entry

puts 'vm.c'
File.open('vm.c', 'w') { |fd|
	fd.puts t2dasm.decompile(t2entry)
}
